var languages = {
  en: ["English", ["de", "fr", "nl", "el", "zh", "it", "ja", "ru", "es"]],
  de: ["German", ["en", "fr"]],
  fr: ["French", ["en", "de"]],
  es: ["Spanish", ["en"]],
  it: ["Italian", ["en"]],
  zh: ["Chinese", ["en"]],
  ja: ["Japanese", ["en"]],
  ru: ["Russian", ["en"]],
  sq: ["Albanian", ["en"]],
  ar: ["Arabic", ["en"]],
  bg: ["Bulgarian", ["en"]],
  ca: ["Catalan", ["en"]],
  hr: ["Croatian", ["en"]],
  cs: ["Czech", ["en"]],
  da: ["Danish", ["en"]],
  nl: ["Dutch", ["en"]],
  ee: ["Estonian", ["en"]],
  tl: ["Filipino", ["en"]],
  fi: ["Finnish", ["en"]],
  gl: ["Galician", ["en"]],
  el: ["Greek", ["en"]],
  iw: ["Hebrew", ["en"]],
  hi: ["Hindi", ["en"]],
  hu: ["Hungarian", ["en"]],
  id: ["Indonesian", ["en"]],
  ko: ["Korean", ["en"]],
  lv: ["Latvian", ["en"]],
  lt: ["Lithuanian", ["en"]],
  mt: ["Maltese", ["en"]],
  no: ["Norwegian", ["en"]],
  pl: ["Polish", ["en"]],
  pt: ["Portuguese", ["en"]],
  ro: ["Romanian", ["en"]],
  sr: ["Serbian", ["en"]],
  sk: ["Slovak", ["en"]],
  sl: ["Slovenian", ["en"]],
  sv: ["Swedish", ["en"]],
  th: ["Thai", ["en"]],
  tr: ["Turkish", ["en"]],
  uk: ["Ukrainian", ["en"]],
  vi: ["Vietnamese", ["en"]]
}

    function translatorSetup() {
      var langs = new Array();
      var nums = new Object();
      for (var i in languages) {
        nums[i] = langs.length;
        langs.push(i + "");
      }
      for (var i in languages) {
        var src = i;
        var array = langs.slice();
        //array.splice(nums[i], 1);
        languages[i][1] = array;
      }
      for (var i in languages) {
      	var option = document.createElement("option");
      	option.value = i;
      	option.innerHTML = languages[i][0];
      	$("SourceLanguage").appendChild(option);
      }
      sourceSelected();
      if (navigator.language) {
        $("SinkLanguage").value = navigator.language.substring(0, 2);
      }  
    }
    
    function sourceSelected() {
      var value = $("SourceLanguage").value;
      widget.setPreferenceForKey(value, widget.identifier + "-source");
      if (value.length == 0) {
        value = "en";
      }
      $("LanguageDetectText").style.visibility = "hidden";
      fillSinkSelect(value);
      translate();
    }   
    
    function fillSinkSelect(source) {
      var oldValue = $("SinkLanguage").value;
      var langs = languages[source][1];
      $("SinkLanguage").innerHTML = "";
      for (var i = 0; i < langs.length; i++) {
      	var option = document.createElement("option");
      	option.value = langs[i];
      	option.innerHTML = languages[langs[i]][0];
      	$("SinkLanguage").appendChild(option);
      }
      $("SinkLanguage").value = oldValue;
      widget.setPreferenceForKey($("SinkLanguage").value, widget.identifier + "-sink");
    }
    
    function translate() {
      widget.setPreferenceForKey($("SinkLanguage").value, widget.identifier + "-sink");
      var text = $("Source").value;
      if (text.length > 0) {
        var source = $("SourceLanguage").value;
        if (source.length == 0) {
          $("Translation").value = "Detect language...";
          google.language.detect(text, function(result) {
            if (!result.error) {
              var language = languages[result.language];
              if (language) {
                $("LanguageDetect").innerHTML =  language[0];
                fillSinkSelect(result.language);
                $("LanguageDetectText").style.visibility = "visible";
                doTranslation(text, source);
              }
              else {
                $("Translation").value = "Language detection failed or language not supported. Please select manually.";                              
              }  
            }
            else {
              $("Translation").value = result.error.message;              
            }
          });          
        }
        else {
          doTranslation(text, source);
        }
      }
      else {
        $("Translation").value = "";        
      }  
    }
    
    function doTranslation(text, source) {
      $("Translation").value = "Translating...";
      google.language.translate(text, source, $("SinkLanguage").value, function(result) {
        if (!result.error) {
          $("Translation").value = result.translation;
        }
        else {
          $("Translation").value = result.error.message;
        }
      });      
    }